<?php
/**
 * @version     1.2.3
 * @package     Virtuemart.Plugin
 * @subpackage  Vmpayment.bifit
 *
 * @copyright   Copyright (C) 2021 BIFIT. All rights reserved.
 * @license     GNU General Public License version 2 or later
 */

defined('_JEXEC') or die;

class JFormFieldStatuses extends JFormField
{
	protected $type = 'statuses';

	public function getInput()
	{
		require_once JPATH_ROOT .
			'/administrator/components/com_virtuemart/helpers/config.php';

		VmConfig::loadConfig();
		VmConfig::loadJLang('com_virtuemart', true);

		$model = VmModel::getModel('orderstatus');
		$statuses = $model->getOrderStatusList(false);

		foreach ($statuses as $key => $os) {
			$statuses[$key]->order_status_name = vmText::_(
				$os->order_status_name
			);
		}

		$name = $this->name . '[]';
		$value = empty($this->value) ? '' : $this->value;

		return JHTML::_(
			'select.genericlist',
			$statuses,
			$name,
			'class="inputbox" id="statuses" multiple="multiple"',
			'order_status_code',
			'order_status_name',
			$value
		);
	}
}