<?php
/**
 * @version     1.2.3
 * @package     Virtuemart.Plugin
 * @subpackage  Vmpayment.bifit
 *
 * @copyright   Copyright (C) 2021 BIFIT. All rights reserved.
 * @license     GNU General Public License version 2 or later
 */

defined('_JEXEC') or die;

JHTML::_('behavior.modal', 'a.modal');

class JFormFieldTransactions extends JFormField
{
	protected $type = 'transactions';

	public function getLabel()
	{
		return null;
	}

	public function getInput()
	{
		// параметры
		$app = JFactory::getApplication();
		$del = JRequest::getInt('del', null);
		$log = JRequest::getInt('log', null);

		$url = JURI::current() . '?';
		$url .= 'option=com_plugins&';
		$url .= 'view=plugin&';
		$url .= 'layout=edit&';
		$url .= 'extension_id=' . JRequest::getInt('extension_id');

		// удаление записи
		if ($del) {
			$db = JFactory::getDbo();
			$db->setQuery(
				$db
					->getQuery(true)
					->delete($db->quoteName('#__virtuemart_bifit_reports'))
					->where($db->quoteName('id') . ' = ' . $del)
			);

			if ($db->execute()) {
				$app->redirect(
					$url,
					JText::_('PLG_VMPAYMENT_BIFIT_DEL_SUCCESS')
				);
			} else {
				$app->redirect(
					$url,
					JText::_('PLG_VMPAYMENT_BIFIT_DEL_ERROR_OCCURR'),
					'error'
				);
			}
		}

		// запрос в бд
		$db = JFactory::getDbo();
		$db->setQuery(
			$db
				->getQuery(true)
				->select('*')
				->from($db->quoteName('#__virtuemart_bifit_reports'))
				->order($db->quoteName('id') . ' DESC')
		);
		$actions = $db->execute() ? $db->loadObjectList() : array();

		// пагинация
		$context = "virtuemart.list.admin.bifit_actions";
		$limit = $app->getUserStateFromRequest(
			$context . 'limit',
			'limit',
			$app->getCfg('list_limit'),
			'int'
		);
		$limitstart = $app->getUserStateFromRequest(
			$context . 'limitstart',
			'limitstart',
			0,
			'int'
		);
		$total = count($actions);
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		$actions = array_slice(
			$actions,
			$pagination->limitstart,
			$pagination->limit
		);
		$d = "document.getElementById('style-form').id='adminForm';";
		$s = "document.adminForm.limitstart";
		$listFooter = str_replace($s, $d . $s, $pagination->getListFooter());
		$s = "Joomla.submitform();";
		$limitBox = str_replace($s, $d . $s, $pagination->getLimitBox());

		// стили css
		$html =
			'<style type="text/css">.table th.text-center{text-align:center}#bifit a.order_number {text-decoration:none;border-bottom: 1px dashed} #bifit a.order_number:hover {text-decoration:none;border-bottom: 1px solid} #bifit a.remove {color:darkred}.form-horizontal #attrib-report .control-label{display:none}.form-horizontal #attrib-report .controls{margin-left:0}span.error{font-weight:700;letter-spacing:.1em;color:red}span.success{font-weight:700;letter-spacing:.1em;color:forestgreen}span.type{padding:4px 10px;border-radius:4px;color:white;background:green}span.type-error{opacity:.5}span.type.type-sale{background:forestgreen;color:white}span.type.type-sale_return{background:lightgreen;color:black}span.type.type-purchase{background:lightslategrey;color:white}span.type.type-purchase_return{background:lightslateblue;color:black}</style>';

		// транзакции
		if (count($actions)) {
			// таблица
			$html .= '<table id="bifit" class="table table-striped">';

			// заголовки
			$html .= '<thead>';
			$html .= '<tr>';
			$html .= '<th class="nowrap">#</th>';
			$html .=
				'<th class="nowrap">' .
				JText::_('PLG_VMPAYMENT_BIFIT_ORDER_ID') .
				'</th>';
			$html .=
				'<th class="nowrap">' .
				JText::_('PLG_VMPAYMENT_BIFIT_ORDER_NUMBER') .
				'</th>';
			$html .=
				'<th class="nowrap hidden-phone">' .
				JText::_('PLG_VMPAYMENT_BIFIT_ORDER_DATE') .
				'</th>';
			$html .=
				'<th class="nowrap hidden-phone">' .
				JText::_('PLG_VMPAYMENT_BIFIT_ACTION_DATE') .
				'</th>';
			$html .=
				'<th class="nowrap">' .
				JText::_('PLG_VMPAYMENT_BIFIT_RECEIPT') .
				'</th>';
			$html .=
				'<th><span class="hidden-phone">' .
				JText::_('PLG_VMPAYMENT_BIFIT_DOCUMENT') .
				'</span><span class="visible-phone">' .
				JText::_('PLG_VMPAYMENT_BIFIT_DOC') .
				'</span></th>';
			$html .=
				'<th class="nowrap">' .
				JText::_('PLG_VMPAYMENT_BIFIT_LOG') .
				'</th>';
			$html .=
				'<th class="nowrap hidden-phone">' .
				JText::_('PLG_VMPAYMENT_BIFIT_TYPE') .
				'</th>';
			$html .=
				'<th class="text-center"><span class="hidden-phone">' .
				JText::_('PLG_VMPAYMENT_BIFIT_REMOVE') .
				'</span><span class="visible-phone">' .
				JText::_('PLG_VMPAYMENT_BIFIT_DEL') .
				'</span></th>';
			$html .= '</tr>';
			$html .= '</thead>';

			// центр
			$html .= '<tbody>';

			// список транзакций
			foreach ($actions as $key_id => $action) {
				$html .= '<tr>';

				// порядковый номер
				$html .= '<td>' . ($limitstart + $key_id + 1) . '</td>';
				// id заказа
				$html .=
					'<td><a target="_blank" class="btn btn-small btn-default" href="' .
					JURI::current() .
					'?option=com_virtuemart&view=orders&task=edit&virtuemart_order_id=' .
					$action->order_id .
					'">№' .
					$action->order_id .
					'</a></td>';
				// номер заказа
				$html .=
					'<td><a target="_blank" class="order_number" href="' .
					JURI::current() .
					'?option=com_virtuemart&view=orders&task=edit&virtuemart_order_id=' .
					$action->order_id .
					'">№' .
					$action->order_number .
					'</a></td>';
				// дата заказа
				$html .=
					'<td class="nowrap hidden-phone"><span class="icon icon-calendar"></span> ' .
					$action->order_date .
					'</td>';
				// дата запроса
				$html .=
					'<td class="nowrap hidden-phone"><span class="icon icon-calendar"></span> ' .
					(isset($action->action_date)
						? $action->action_date
						: $action->order_date) .
					'</td>';
				// ссылка на чек
				$html .=
					'<td>' .
					((int) $action->receipt_id > 0
						? '<a target="_blank" href="' .
							$action->receipt_link .
							'" class="btn btn-small btn-primary"><span class="icon icon-link"></span> <span class="hidden-phone">' .
							JText::_('PLG_VMPAYMENT_BIFIT_OPEN') .
							'</span></a>'
						: '<span class="error">' .
							'<span class="icon icon-warning"></span>' .
							JText::_('PLG_VMPAYMENT_BIFIT_NO') .
							'</span>') .
					'</td>';
				// документ
				$html .=
					'<td>' .
					'<span class="' .
					((int) $action->receipt_id > 0 ? 'success' : 'error') .
					'">' .
					'<span class="icon icon-' .
					((int) $action->receipt_id > 0 ? 'tag' : 'warning') .
					'"></span>' .
					((int) $action->receipt_id > 0
						? (int) $action->receipt_id
						: JText::_('PLG_VMPAYMENT_BIFIT_NO')) .
					'</span>' .
					'</td>';
				// лог-файл
				$html .=
					'<td><a href="#log' .
					$action->id .
					'" class="btn btn-small btn-' .
					((int) $action->receipt_id > 0 ? 'success' : 'danger') .
					' modal"><span class="icon icon-file-2"></span> <span class="hidden-phone">' .
					JText::_('PLG_VMPAYMENT_BIFIT_VIEW') .
					'</span></a><div style="display:none"><div id="log' .
					$action->id .
					'">' .
					str_replace("\n", "<br>", $action->log) .
					'</div></div></td>';
				// тип документа
				$html .=
					'<td class="nowrap hidden-phone">' .
					'<span class="type ' .
					((int) $action->receipt_id > 0
						? 'type-success'
						: 'type-error') .
					' type-' .
					JString::strtolower($action->receipt_type) .
					'">' .
					JText::_(
						'PLG_VMPAYMENT_BIFIT_RECEIPT_TYPE_' .
							$action->receipt_type
					) .
					'</span>' .
					'</td>';
				// удалить
				$html .=
					'<td style="text-align:center;"><a href="' .
					$url .
					'&del=' .
					$action->id .
					'" class="remove"><span class="icon icon-trash"></span></a></td>';

				$html .= '</tr>';
			}

			$html .= '</tbody>';

			// подвал
			$html .= '<tfoot>';
			$html .= '<tr>';
			$html .= '<td colspan="10">';
			$html .= '<div class="pull-left">' . $listFooter . '</div>';
			$html .= '<div class="pull-right">' . $limitBox . '</div>';
			$html .= '</td>';
			$html .= '</tr>';
			$html .= '</tfoot>';

			$html .= '</table>';
		} else {
			$html .=
				'<div class="alert alert-info"><strong>' .
				JText::_('PLG_VMPAYMENT_BIFIT_EMPTY_ACTIONS_LIST') .
				'</strong></div>';
		}

		return $html;
	}
}